var GEOIP_LOOKUP_URL = "http://tetra.emeraldion.it/3dip_lookup.wdgt.php",
	DONATE_URL = "http://www.emeraldion.it/donate/",
	FEEDBACK_URL = "http://www.emeraldion.it/software/widgets/3diplookup/comments/",
	EME_HOME = "http://www.emeraldion.it",
	CLOCKWISE = 0,
    CCLOCKWISE = 1,
    UP = -1,
    DOWN = 1;

var result = null,
	flipShown = false,
	configured = false,
	drawer = null,
	throbber = null,
	animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null},
	bouncers = {},
	shouldAbort = false;
	
function setup()
{
	drawer = new Drawer("drawer");
	//throbber = new Throbber("throbber");
	
	createGenericButton(document.getElementById("done"),
						getLocalizedString("Done"),
						flipToFront);
/*						
	createGenericButton(document.getElementById("donate"),
						getLocalizedString("Donate"),
						donate);
*/
	createGenericButton(document.getElementById("feedback"),
						getLocalizedString("Feedback"),
						feedback);
/*
	createGenericButton(document.getElementById("help"),
						getLocalizedString("?"),
						help);
*/
	document.getElementById("q").setAttribute("placeholder", getLocalizedString("URL or IP address"));
}

function feedback()
{
	openUrl(FEEDBACK_URL);
}

function donate()
{
	openUrl(DONATE_URL);
}

function help()
{
}

function ip_lookup(q)
{
	if (q != "")
	{
		if (!drawer.visible)
			drawer.toggle();
		//throbber.startAnimation();
		setTimeout(traceroute, 500, q);
	}
	else
	{
		clearAll();
		if (drawer.visible)
			drawer.toggle();		
	}
}

function traceroute(ip)
{
	highlight("terminal");
	bouncers["terminal"] = new Bouncer("terminal");
	bouncers["terminal"].bounceStart(1000);
	setStatus(getLocalizedString("Launched traceroute on ") + ip);
	result = widget.system("/usr/sbin/traceroute " + ip,
							function()
							{
								bouncers["terminal"].bounceStop();
								setStatus(getLocalizedString("Got traceroute output"));
								var trace = result.outputString;
								lookup(trace);
							});
	result.onreaderror = log;
}

function lookup(trace)
{
	highlight("network");
	bouncers["network"] = new Bouncer("network");
	bouncers["network"].bounceStart(1000);
	setStatus(getLocalizedString("Performing IP lookup"));
	var filename = "/var/tmp/3dip_lookup-" + (new Date().getTime()) + ".kml";
	var command = "/usr/bin/curl " + 
					'-d "iam=widget&mode=trace&link=true&&trace=' + encodeURIComponent(trace) + '" ' +
					'-o "' + filename + '" ' +
					GEOIP_LOOKUP_URL;
	result = widget.system(command,
							function()
							{
								bouncers["network"].bounceStop();
								setStatus(getLocalizedString("Written KML file ") + filename);
								var kml = result.outputString;
								open_in_googleearth(filename);
							});
	result.onreaderror = log;
}

function open_in_googleearth(kmlfile)
{
	highlight("googleearth");
	bouncers["googleearth"] = new Bouncer("googleearth");
	bouncers["googleearth"].bounceStart(1000);
	setStatus(getLocalizedString("Launching Google Earth"));
	var command = "/usr/bin/open " + kmlfile;
	result = widget.system(command,
							function()
							{
								bouncers["googleearth"].bounceStop();
								setStatus(getLocalizedString("Done"));
								//throbber.stopAnimation();
								setTimeout(launch_googleearth, 2000);
								setTimeout(clearAll, 3000);
							});
	result.onreaderror = log;
}

function log(output)
{
	// Just flush to the Console log...
	alert(output);
}

function launch_terminal()
{
	widget.openApplication("com.apple.Terminal");
}

function launch_network()
{
	widget.openApplication("com.apple.NetworkUtility");
}

function launch_googleearth()
{
	// What a UGLY hack :p
	widget.openApplication("com.Google.GoogleEarth");
	widget.openApplication("com.Google.GoogleEarthPlus");
}

function clearAll()
{
	// Interrupt running command
	result.cancel();
	// Stop bouncing icons
	for (var i in bouncers)
		bouncers[i].bounceStop();
	clear("terminal");
	clear("network");
	clear("googleearth");
	// Update status
	setStatus(getLocalizedString("Idle"));
}

function setStatus(stat)
{
	document.getElementById("status").innerHTML = stat;
}

function highlight(icon)
{
	document.getElementById(icon).src = "Images/" + icon + ".png";
}

function clear(icon)
{
	document.getElementById(icon).src = "Images/" + icon + "-clear.png";
}

function Bouncer(icon)
{
	this.bouncer = {
		duration: 650,
		starttime: 0,
		to: 10,
		now: 0,
		from: 20,
		firstElement: document.getElementById(icon),
		timer: null,
		times: 1
	};
	this.bounce = function() 
	{
		var T;
		var ease;
		var time = (new Date).getTime();

		T = limit_3(time-this.bouncer.starttime, 0, this.bouncer.duration * this.bouncer.times);

		if (T >= this.bouncer.duration * this.bouncer.times) {
			// The duration of animation has reached the total time
			// needed by the required bounces. We reposition the duck
			// to its rest position.

			clearInterval (this.bouncer.timer);
			this.bouncer.timer = null;
			this.bouncer.now = this.bouncer.from;
		}
		else if (this.bouncer.shouldStop) {
			// We adjust the number of bounces, this.bouncer.times, to finish
			// the current bounce
	
			this.bouncer.times = Math.ceil(T / this.bouncer.duration);
			this.bouncer.shouldStop = false;
		}
		else {
			ease = Math.abs(Math.sin(Math.PI * T / this.bouncer.duration));
			this.bouncer.now = computeNextInt (this.bouncer.from, this.bouncer.to, ease);
		}
	
		this.bouncer.firstElement.style.top = this.bouncer.now + "px";
	}
	
	this.bounceStop = function()
	{
		// Simply signals that this is the last bounce
		this.bouncer.shouldStop = true;
	}
	
	this.bounceStart = function(times)
	{
		if (this.bouncer.timer) {
			clearInterval (this.bouncer.timer);
			this.bouncer.timer = null;
		}
	
		var starttime = (new Date).getTime() - 11;
	
		this.bouncer.shouldStop = false;
		this.bouncer.duration = 650;
		this.bouncer.starttime = starttime;
		this.bouncer.timer = setInterval (function(obj) { obj.bounce(); }, 11, this);
		this.bouncer.from = 20;
		this.bouncer.to = 10;
		this.bouncer.times = times || 1;
		this.bounce();
	}
}

function limit_3 (a, b, c) {
	return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease) {
	return from + (to - from) * ease;
}

function computeNextInt (from, to, ease) {
	return Math.round(from + (to - from) * ease);
}

function in_range(val, a, b)
{
	return (a == Math.min(a, b)) ? limit_3(val, a, b) : limit_3(val, b, a);
}


function enterflip(event) {
	showObj("fliprollie");
}

function exitflip(event) {
	hideObj("fliprollie");
}

function getLocalizedString (key) {
	try {
		var ret = localizedStrings[key];
		if (ret === undefined) {
			ret = key;
		}
		return ret;
	}
	catch (ex) {
		//
	}
	return key;
}

function Drawer(id)
{
	this.drawer = document.getElementById(id);
	this.offset = this.REST_Y;
	this.direction = UP;
	this.timer = null;
	this.visible = false;
	this.shouldClose = false;

	this.toggle = function()
	{
		// Clear reopen reminder
		this.shouldClose = false;
		if (this.timer)
			clearInterval(this.timer);
		if (!this.visible)
			// Must be displayed before scrolling
			this.drawer.style.display = "block";
		this.direction = (this.direction == UP) ? DOWN : UP;
		this.timer = setInterval(function(drw) { drw.scroll(); }, this.INTERVAL, this);
		this.startTime = new Date().getTime();
		this.visible = !this.visible;
		this.from = this.offset;
		this.to = (this.direction == UP) ?
			this.REST_Y :
			0;
	};
	this.scroll = function()
	{
		var elapsed = new Date().getTime() - this.startTime;
		this.offset = in_range(Math.round(this.from + elapsed * (this.to - this.from) / (this.DURATION)),
			this.from,
			this.to);
		this.drawer.style.marginTop = 19 + this.offset + "px";
		this.drawer.style.clip = "rect(" + limit_3(-this.offset, 0, 1000) + "px,auto,auto,auto)";
		if (elapsed >= this.DURATION)
		{
			clearInterval(this.timer);
		}
	};
	this.markForClose = function()
	{
		this.shouldClose = true;
	};
}
Drawer.prototype.INTERVAL = 46;
Drawer.prototype.DURATION = 500;
Drawer.prototype.REST_Y = -82;

function flipToBack(event)
{
	event.stopPropagation();
	event.preventDefault();

	if (!drawer.visible)
	{
		drawer.toggle();
		drawer.markForClose();
		// Wait for drawer to scroll...
		setTimeout(doFlipToBack, 1.2 * drawer.DURATION);
	}
	else
	{
		// Flip immediately
		doFlipToBack();
	}
}

function doFlipToBack()
{
	if (window.widget)
		widget.prepareForTransition("ToBack");

	document.getElementById("front").style.display = "none";
	document.getElementById("back").style.display = "block";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);
}

function flipToFront(event)
{
	if (window.widget)
		widget.prepareForTransition("ToFront");

	document.getElementById("back").style.display = "none";
	document.getElementById("front").style.display = "block";
	
	if (window.widget)
		setTimeout('widget.performTransition();', 0);

	// Reopen drawer if needed
	if (drawer.shouldClose)
	{
		// Allow 1 second for the flip animation
		setTimeout(function(drw){ drw.toggle(); }, 1000, drawer);
	}
}

function Throbber(img_id)
{
	/* The number of possible states (different frames) */
	this.STATES = 12;
	/* The interval between two frames in milliseconds */
	this.INTERVAL = 67;

	this.throbber = document.getElementById(img_id);
	this.state = 0;
	this.direction = CLOCKWISE;
	this.running = false;

	this.setDirection = function(dir)
	{
		var was_running = this.running;
		if (was_running)
			this.stopAnimation();
		this.direction = dir;
		if (was_running)
			this.startAnimation();
	};
	
	this.startAnimation = function()
	{
		if (this.timer)
			this.stopAnimation();
		this.timer = setInterval(function(t) { t.next(); }, this.INTERVAL, this);
		this.running = true;
	};
	
	this.stopAnimation = function()
	{
		clearInterval(this.timer);
		this.running = false;
	};
	
	this.setIndeterminate = function(really)
	{
		this.throbber.src = (really) ?
			"Images/Throbber/throbber_indeterminate.png" :
			"Images/Throbber/throbber_0.png";
	};

	this.next = function()
	{
		this.state =
			(this.direction == CLOCKWISE) ?
				((this.state + 1) % this.STATES) :
				(this.STATES - (this.state + 1) % this.STATES - 1);
		this.throbber.src = "Images/Throbber/throbber_" + this.state + ".png";
	};

}

function mousemove (event) 
{
	if (!flipShown) {
		if (animation.timer != null) {
			clearInterval (animation.timer);
			animation.timer  = null;
		}
 
		var starttime = (new Date).getTime() - 13;
 
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ("flip");
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}

function mouseexit (event) 
{
	if (flipShown) {
		// fade in the info button
		if (animation.timer != null) {
			clearInterval (animation.timer);
			animation.timer  = null;
		}

		var starttime = (new Date).getTime() - 13;

		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ("flip");
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}

function animate() 
{
	var T;
	var ease;
	var time = (new Date).getTime();
   

	T = limit_3(time-animation.starttime, 0, animation.duration);

	if (T >= animation.duration) {
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else {
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}

	animation.firstElement.style.opacity = animation.now;
}

function openUrl(theURL)
{
	if (window.widget)
		widget.openURL(theURL);
	else
		location.href = theURL;
}