var searchType = "0";
var widgetColor = "green";
var historyArray = new Array();
var historyIndex = 0;
var escapeDown = "no";

//  Dashboard Code (from apple)
function setup() {
	scrollerInit(document.getElementById("myScrollBar"), document.getElementById("myScrollTrack"), document.getElementById("myScrollThumb"));
	document.getElementById('htmlview').innerHTML = "";
	newContent = document.getElementById('htmlview');
	newContent.style.display = 'block';
	calculateAndShowThumb(newContent);
	createGenericButton(document.getElementById('done'), 'Done', hidePrefs);
	window.onkeydown = onKeyDown;
	var openIn = widget.preferenceForKey("openInWebBrowser");
	if (openIn && openIn.length > 0) {
		if (openIn == "true") {
			document.getElementById('openInWebBrowser').checked=true;
		} else {
		}
	}
	widgetColor=widget.preferenceForKey("widgetColor");
	document.getElementById('colorSelect').value=widgetColor;
	if (widgetColor =="blue") {
		document.DefaultImage.src = "Images/Default-blue.png";
	} else if (widgetColor =="black") {
		document.DefaultImage.src = "Images/Default-black.png";
	} else if (widgetColor =="orange") {
		document.DefaultImage.src = "Images/Default-orange.png";
	} else {
		document.DefaultImage.src = "Default.png";
	}
}

function onKeyDown(e) {
	var code = e.keyCode;
	if (code == 27) {
		escapeDown = "yes";
	}
}

function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToBack");
       
	front.style.display="none";
	back.style.display="block";
	exitflip(event);

	if (window.widget)
		setTimeout ('widget.performTransition();', 0);  
}

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	if (window.widget)
		widget.prepareForTransition("ToFront");
      
	back.style.display="none";
	front.style.display="block";

	if (window.widget)
		setTimeout ('widget.performTransition();', 0);
}

var flipShown = false;
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

function mousemove (event)
{
	if (!flipShown)
	{
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
 
		var starttime = (new Date).getTime() - 13;
 
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}
function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the info button
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}

		var starttime = (new Date).getTime() - 13;

		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
	escapeDown = "no";
}

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
   

	T = limit_3(time-animation.starttime, 0, animation.duration);

	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}

	animation.firstElement.style.opacity = animation.now;
}

function limit_3 (a, b, c)
{
	return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
	return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}

function openURLInBrowser(theURL)
{
	if (window.widget) {
		theURL = encodeURI(theURL);
		widget.system("open '"+ theURL +"'", null);
		widget.openURL('');
	}
}

var HTTPReq;

function processHTTPReq(theURL,recordHistory)
{	
	HTTPReq = false;
	HTTPReq = new XMLHttpRequest();
	HTTPReq.onreadystatechange = checkHTTPReq;
	if (theURL.match("www.google.com/xhtml/")=="www.google.com/xhtml/") 
	{
		if (escapeDown=="yes") 
			openURLInBrowser(theURL);
		else {
			HTTPReq.open( "GET", encodeURI(theURL), true );
			if (recordHistory=='true')
				recordURLInHistory(theURL);
		}
	}
	else if (theURL.match("www.google.com/gwt/")=="www.google.com/gwt/")
	{
		if (document.getElementById('openInWebBrowser').checked==true) {
			if (escapeDown=="yes") {
				HTTPReq.open( "GET", encodeURI(theURL), false );
				if (recordHistory=='true')
					recordURLInHistory(theURL);
			} else {
				theURL = theURL.replace(/&_gwt_pg=[0-9]+/,"");
				openURLInBrowser(theURL+"&_gwt_pg=orig");
			}
		} else {
			if (escapeDown=="yes") {
				theURL = theURL.replace(/&_gwt_pg=[0-9]+/,"");
				openURLInBrowser(theURL+"&_gwt_pg=orig");
			} else {
				HTTPReq.open( "GET", encodeURI(theURL), false );
				if (recordHistory=='true')
					recordURLInHistory(theURL);
			}
		}
	} else if (theURL!="" && theURL!="<search></search>") {
		if (searchType==0 && theURL.match(/<search>([^\n]+)<\/search>/)!=null) {
			if (escapeDown=="yes") {
				searchPattern = /<search>([^\n]+)<\/search>/;
				searchReplace = "http://www.google.com/search?hl=en&q=$1&btnG=Google+Search";
				theURL = theURL.replace(searchPattern,searchReplace);
			} else {
				searchPattern = /<search>([^\n]+)<\/search>/;
				searchReplace = "http://www.google.com/xhtml/search?mrestrict=xhtml&q=$1&btnG=Search&site=search";
				theURL = theURL.replace(searchPattern,searchReplace);
			}
		} else if (searchType==1 && theURL.match(/<search>([^\n]+)<\/search>/)!=null) {
			if (escapeDown=="yes") {
				searchPattern = /<search>([^\n]+)<\/search>/;
				searchReplace = "http://images.google.com/images?hl=en&q=$1&btnG=Google+Search&ie=UTF-8&oe=UTF-8&sa=N&tab=wi";
				theURL = theURL.replace(searchPattern,searchReplace);
			} else {
				searchPattern = /<search>([^\n]+)<\/search>/;
				searchReplace = "http://www.google.com/xhtml/search?mrestrict=xhtml&q=$1&btnG=Search&site=images";
				theURL = theURL.replace(searchPattern,searchReplace);
			}
		} else if (searchType==2 && theURL.match(/<search>([^\n]+)<\/search>/)!=null) {
			if (escapeDown=="yes") {
				searchPattern = /<search>([^\n]+)<\/search>/;
				searchReplace = "http://news.google.com/news?hl=en&q=$1&btnG=Google+Search&ie=UTF-8&oe=UTF-8&sa=N&tab=in";
				theURL = theURL.replace(searchPattern,searchReplace);
			} else {
				searchPattern = /<search>([^\n]+)<\/search>/;
				searchReplace = "http://news.google.com/news?q=$1&hl=en&edition=us&output=xhtml&btnG=Search+News";
				theURL = theURL.replace(searchPattern,searchReplace);
			}
		}
		if (escapeDown=="yes") {
			openURLInBrowser(theURL);
		} else {
			HTTPReq.open( "GET", theURL, true );
			if (recordHistory=='true')
				recordURLInHistory(theURL);
		}
	} else {
		document.getElementById('htmlview').innerHTML = "";
		newContent = document.getElementById('htmlview');
		newContent.style.display = 'block';
		calculateAndShowThumb(newContent);
		colapseWidget();
	}

	
	HTTPReq.send( null );
}

function checkHTTPReq()
{
	if ( HTTPReq.readyState == 4 ) 
	{
		if ( HTTPReq.status == 200 )
		{
			formatAndDisplay(HTTPReq.responseText);
		}
		else
		{
		}
	}
}

function formatAndDisplay(aContent)
{
	header1Pattern = /<div><img style="vertical-align:middle;" src="\/xhtml\/images\/google.gif" alt="Google"\/>\n\s*<\/div>/gi;
	header1Replace = "";
	aContent = aContent.replace(header1Pattern, header1Replace);

	header2Pattern = /<div class="smallest" style="vertical-align:middle;"><img style="vertical-align:middle;" src="http:\/\/www.google.com\/images\/logo_smallest.gif" alt="Google"\/>&nbsp;News<span style="color:#666666"> beta<\/span><\/div>/gi;
	header2Replace = "";
	aContent = aContent.replace(header2Pattern, header2Replace);

	header3Pattern = /<div><b>[\s\S]* results:<\/b>[\s\S]*Results ([\s\S]*) of about ([0123456789,]*).\s*<br\/>\s*<\/div>/i;
	header3Replace = "<div><b>Results $1 of about $2.</b><br/></div>";
	aContent = aContent.replace(header3Pattern, header3Replace);

	footerPattern = /<br\/>4 <a accesskey="4" href="\S+">Back to results<\/a>/gi;
	footerReplace = "";
	aContent = aContent.replace(footerPattern, footerReplace);
	
	footer1Pattern = /<br\/>5 <a accesskey="5" href="\S+">Google Home<\/a>/gi;
	footer1Replace = "";
	aContent = aContent.replace(footer1Pattern, footer1Replace);
	
	footer2Pattern = /<form method="get" action="\/m"><input value="gwt" type="hidden" name="source"\/><input value="en" type="hidden" name="hl"\/><input value="UTF-8" type="hidden" name="ie"\/><input value="[\S\s]+" type="hidden" name="[\S\s]+"\/><input value="xhtml" type="hidden" name="mrestrict"\/><input value="[\S\s]+" maxlength="2048" type="text" size="15" name="q"\/><input value="Search" type="submit" name="btnG"\/><\/form>/gi;
	footer2Replace = "";
	aContent = aContent.replace(footer2Pattern, footer2Replace);

	footer3Pattern = /<hr\/>Page adapted for mobile phone.  View in <a href="\S+">HTML<\/a>.<br\/><a href="\S+">Report<\/a> problem.<\/div>/gi;
	footer3Replace = "";
	aContent = aContent.replace(footer3Pattern, footer3Replace);
	
	footer4Pattern = /<form action="\/xhtml\/search">[\s\S]*<\/form>[\s\S]*<\/body>/g;
	footer4Replace = "</body>";
	aContent = aContent.replace(footer4Pattern, footer4Replace);

	footer5Pattern = /<div>\*Pages may have been adapted for your mobile phone. <a href="[\s\S]*"\s*>Learn more<\/a>\s*<\/div><hr\/>/gi
	footer5Replace = "";
	aContent = aContent.replace(footer5Pattern, footer5Replace);

	footer6Pattern = /<form method="get" action="\/news">[\s\S]*2006 Google<\/div><\/body>/gi;
	footer6Replace = "</body>";
	aContent = aContent.replace(footer6Pattern, footer6Replace);

	footer7Pattern = /<hr\/>Page adapted for mobile phone.  View in <a href="\S*">HTML<\/a>\./gi;
	footer7Replace = "";
	aContent = aContent.replace(footer7Pattern, footer7Replace);

	footer8Pattern = /<br\/>5 <a accesskey="5" href="\S*">Google News<\/a>/gi;
	footer8Replace = "";
	aContent = aContent.replace(footer8Pattern, footer8Replace);
	
	body1Pattern = /<div><b>[0-9]+ <\/b><a accesskey="[0-9]+"/gi;
	body1Replace = "<div><a";
	aContent = aContent.replace(body1Pattern, body1Replace);

	body2Pattern = /<a accesskey="[0-9]+" href="(\S*)"\s*>[0-9]+<\/a> ([\S \t]+)&nbsp;-/gi;
	body2Replace = "<a href=\"$1\">$2</a>&nbsp;-";
	aContent = aContent.replace(body2Pattern, body2Replace);
	
	style1Pattern = /style="background-color:#9ACEFF"/g;
	style1Replace = "";
	aContent = aContent.replace(style1Pattern, style1Replace);

	linkPattern = /href=\s*"\/(\S+)"/gi;
	linkReplace = "href=\"javascript: processHTTPReq(\'http://www.google.com/$1\',\'true\');\"";
	aContent = aContent.replace(linkPattern, linkReplace);

	imgPattern = /"\/gwt\/i/g;
	imgReplace = "\"http://www.google.com/gwt/i";
	aContent = aContent.replace(imgPattern, imgReplace);

	formPattern = /action=\s*"\/(\S+)"/gi;
	normalURL = historyArray[0].replace(/&_gwt_pg=[0-9]+/,"");
	formReplace = "onClick=\"openURLInBrowser(\'"+ normalURL+"&_gwt_pg=orig"+"\');\"";
	aContent = aContent.replace(formPattern, formReplace);

	otherLinkPattern = /href=\s*"(\S+)"/gi;
	otherLinkReplace = "href=\"javascript: processHTTPReq(\'$1\',\'true\')\"";
	aContent = aContent.replace(otherLinkPattern, otherLinkReplace);

	aContent = aContent + "<br/><br/>";
	
	expandWidget();
	document.getElementById('htmlview').innerHTML = aContent;
	newContent = document.getElementById('htmlview');
	newContent.style.display = 'block';
	calculateAndShowThumb(newContent);
	scrollBy(5500000);
	
}

function popupMenuOver() {
	var popupMenu = document.getElementById("popupMenu");
	popupMenu.src = "Images/popupMenuOver.png";
}

function popupMenuOut() {
	var popupMenu = document.getElementById("popupMenu");
	popupMenu.src = "Images/popupMenu.png";
}

function handlePopupMenuList() {
	if (popupMenuList.style.display == "none")
		popupMenuList.style.display = "block";
	else
		popupMenuList.style.display = "none";
}

function categorySelected(element) {
	if (element.innerText=="Web") {
		searchType = 0;
		chosenCategory.innerText = "Web";
	} else if (element.innerText=="Images") {
		searchType = 1;
		chosenCategory.innerText = "Images";
	} else if (element.innerText=="News") {
		searchType = 2;
		chosenCategory.innerText = "News";
	}
	
	processHTTPReq("<search>"+document.getElementById('searchField').value+"</search>",'true');
	handlePopupMenuList();	
}

function refreshCheckboxPrefs() {
	if (document.getElementById('openInWebBrowser').checked == true) {
		widget.setPreferenceForKey("true","openInWebBrowser");
	} else {
		widget.setPreferenceForKey("false","openInWebBrowser");
	}
}

function refreshColorPrefs(value) {
	if (value =="green") {
		widgetColor="green";
		if (document.DefaultImage.src. match("Default-open") == "Default-open") {
			document.DefaultImage.src = "Images/Default-open.png";
		} else {
			document.DefaultImage.src = "Default.png";
		}
		widget.setPreferenceForKey("green","widgetColor");
	} else if (value =="blue") {
		widgetColor="blue";
		if (document.DefaultImage.src.match("Default-open") == "Default-open") {
			document.DefaultImage.src = "Images/Default-open-blue.png";
		} else {
			document.DefaultImage.src = "Images/Default-blue.png";
		}
		widget.setPreferenceForKey("blue","widgetColor");
	} else if (value=="black") {
		widgetColor="black";
		if (document.DefaultImage.src. match("Default-open") == "Default-open") {
			document.DefaultImage.src = "Images/Default-open-black.png";
		} else {
			document.DefaultImage.src = "Images/Default-black.png";
		}
		widget.setPreferenceForKey("black","widgetColor");
	} else if (value=="orange") {
		widgetColor="orange";
		if (document.DefaultImage.src. match("Default-open") == "Default-open") {
			document.DefaultImage.src = "Images/Default-open-orange.png";
		} else {
			document.DefaultImage.src = "Images/Default-orange.png";
		}
		widget.setPreferenceForKey("orange","widgetColor");
	}
}

function expandWidget() {
	if (widgetColor =="green") {
		document.DefaultImage.src = "Images/Default-open.png";
	} else if (widgetColor =="blue") {
		document.DefaultImage.src = "Images/Default-open-blue.png";
	} else if (widgetColor =="black") {
		document.DefaultImage.src = "Images/Default-open-black.png";
	} else if (widgetColor =="orange") {
		document.DefaultImage.src = "Images/Default-open-orange.png";
	}
}

function colapseWidget() {
	if (widgetColor =="green") {
		document.DefaultImage.src = "Default.png";
	} else if (widgetColor =="blue") {
		document.DefaultImage.src = "Images/Default-blue.png";
	} else if (widgetColor =="black") {
		document.DefaultImage.src = "Images/Default-black.png";
	} else if (widgetColor =="orange") {
		document.DefaultImage.src = "Images/Default-orange.png";
	}
}

function openAlertWithContents(theContents) {
	document.getElementById('alertContents').innerHTML=theContents;
	document.getElementById('alert').style.display='block';
}

function closeAlert() {
	document.getElementById('alert').style.display="none";
}

/******** History stuff *********/

function recordURLInHistory(theURL) {
	historyArray.splice(0,historyIndex,theURL);
	historyIndex=0;
	disableForwardButton();
	if (historyArray.length-1>historyIndex && historyArray.length>1) {
		enableBackButton();
	} else {
		disableBackButton();
	}
}

function historyBackward() {
	if (historyArray.length-1>historyIndex && historyArray.length>1) {
		historyIndex++;
		processHTTPReq(historyArray[historyIndex],'false');
	}
	if (historyArray.length-1>historyIndex && historyArray.length>1) {
		enableBackButton();
	} else {
		disableBackButton();
	}
	if (0<historyIndex) {
		enableForwardButton();
	} else {
		disableForwardButton();
	}
}

function historyForward() {
	if (0<historyIndex) {
		historyIndex--;
		processHTTPReq(historyArray[historyIndex],'false');
	}
	if (0<historyIndex) {
		enableForwardButton();
	} else {
		disableForwardButton();
	}
	if (historyArray.length-1>historyIndex && historyArray.length>1) {
		enableBackButton();
	} else {
		disableBackButton();
	}
}

function enableBackButton() {
	document.getElementById('backButton').src = "Images/backButtonOn.png";
}
function disableBackButton() {
	document.getElementById('backButton').src = "Images/backButtonOff.png";
}
function enableForwardButton() {
	document.getElementById('forwardButton').src = "Images/forwardButtonOn.png";
}
function disableForwardButton() {
	document.getElementById('forwardButton').src = "Images/forwardButtonOff.png";
}
