/**
 * SoccerDB Widget v1.0 (2006-12-03)
 * by Mats Bovin
 * Copyright (c) 2006
 * http://www.mbovin.com/soccerdb
 */


/**
 * Loads stored widget settings.
 */
function loadSettings()
{
	if (window.widget)
	{		
		gCountryId	= widget.preferenceForKey(widget.identifier + '-countryId');
		gGroupId	= widget.preferenceForKey(widget.identifier + '-groupId');
	}
	else // this is for testing in Safari
	{
		gCountryId	= 2;
		gGroupId	= 189;
	}
}

/**
 * Stores the specified widget paramater.
 */
function saveSetting(paramName, paramValue)
{
	if (window.widget)
	{
		widget.setPreferenceForKey(paramValue, widget.identifier + '-' + paramName);
	}
}

/**
 * Formats the specified date on the format YYYY-MM-DD.
 */
function formatDate(date)
{
	var month = date.getMonth() + 1;
	if (month < 10)
		month = '0' + month;
	var day = date.getDate();
	if (day < 10) 
		day = '0' + day;

	return date.getFullYear() + '-' + month + '-' + day;
}

/**
 * Returns the attribute value from an xml node.
 */
function getAttributeValue(xmlNode, attrName)
{
	for (var i = 0; i < xmlNode.attributes.length; i++)
	{
		if (xmlNode.attributes[i].name == attrName)
		{
			return xmlNode.attributes[i].value;
		}
	}
	return false;
}
	
/**
 * Returns the node value of a child node.
 */
function getChildNodeValue(xmlNode, nodeName)
{
	for (var i = 0; i < xmlNode.childNodes.length; i++)
	{
		if (xmlNode.childNodes[i].nodeName == nodeName)
		{
			return xmlNode.childNodes[i].firstChild.nodeValue;
		}
	}
	return false;
}

/**
 * Returns the first CData-child of the specified node.
 */
function getCData(xmlNode)
{
	var cdata = '';
	
	for (var i = 0; i < xmlNode.childNodes.length; i++)
	{
		if (xmlNode.childNodes[i].nodeType == Node.CDATA_SECTION_NODE)
		{
			cdata = xmlNode.childNodes[i].nodeValue;
			break;
		}
	}
	
	return cdata;
}

/**
 * Opens the specified url in a browser window.
 */
function openUrlInBrowser(url)
{
	if (window.widget)
	{
		widget.openURL(url);
	}
	else
	{
		window.open(url, '_blank');
	}
}

