/* Ideum Solar Viewer Widget

   Original: Kevin Silver
   Code updates, bug fixes, proper animation, attribution: James Kassemi (jamesk@ideum.com)

*/

var images = new Array();
var drawer = new Array();
var num;
var focal_image = 0;

setInterval('updateImage(focal_image+1);', 1200000);

drawer[0] = {open:false,id:"drawer_1",button:'learnmore'};
drawer[1] = {open:false,id:"drawer_2",button:'viewmore'};

var text4 = "<p>Extreme Ultraviolet Imaging Telescope image of the Sun from the the Solar and Heliospheric Observatory (SOHO) satellite. (EIT) full-field Fe IX, X 171 Angstroms.</p><p>This image shows the Sun in the extreme ultraviolet portion of the spectrum. This image is produced by extreme ultraviolet (EUV) light from the Sun. This is light that is between ultraviolet light and x-ray light in the electromagnetic spectrum and is not visible to our eyes directly.</p><p>EIT (Extreme Ultraviolet Imaging Telescope) images are taken at four different wavelengths and four colors in order of wavelength (bluer=shorter wavelength, redder=longer) were assigned to represent each of them. Just as the human eye is capable of discriminating different colors in the visible, so EIT's four bandpasses discriminate among four colors in the extreme ultraviolet. In addition, each color table was carefully constructed to bring out typical features of its particular wavelength.</p><p>The red images have a wavelength of 304 Angstroms, the yellow are 284 Angstroms, the green are 195 Angstroms, and the blue are 171 Angstroms. (An Angstrom is a unit of length equal to one hundred-millionth of a centimeter.) So, just like in the visible spectrum red is the longest wavelength and blue is the shortest with yellow and green in between, the EIT image colors were chosen so that the longest wavelength is reddish and the shortest is bluish.</p><p>All of the EIT images are actually produced by extreme ultraviolet (EUV) light from the Sun. This is light that is between ultraviolet light and x-ray light in the electromagnetic spectrum and is not visible to our eyes directly.</p><p>Data supplied courtesy of SOHO. SOHO is a project of international cooperation between ESA and NASA. To learn more visit the Solar and Heliospheric Observatory (SOHO) Website (sohowww.nascom.nasa.gov).</p>";
var text2 = "<p>Extreme Ultraviolet Imaging Telescope image of the Sun from the Solar and Heliospheric Observatory (SOHO) satellite. (EIT) full-field Fe XII, 195 Angstroms.</p><p>This image is actually by extreme ultraviolet (EUV) light from the Sun. This is light that is between ultraviolet light and x-ray light in the electromagnetic spectrum and is not visible to our eyes directly.</p><p>EIT (Extreme Ultraviolet Imaging Telescope) images are taken at four different wavelengths and four colors in order of wavelength (bluer=shorter wavelength, redder=longer) were assigned to represent each of them. Just as the human eye is capable of discriminating different colors in the visible, so EIT's four bandpasses discriminate among four colors in the extreme ultraviolet. In addition, each color table was carefully constructed to bring out typical features of its particular wavelength.</p><p>The red images have a wavelength of 304 Angstroms, the yellow are 284 Angstroms, the green are 195 Angstroms, and the blue are 171 Angstroms. (An Angstrom is a unit of length equal to one hundred-millionth of a centimeter.) So, just like in the visible spectrum red is the longest wavelength and blue is the shortest with yellow and green in between, the EIT image colors were chosen so that the longest wavelength is reddish and the shortest is bluish.</p><p>All of the EIT images are actually produced by extreme ultraviolet (EUV) light from the Sun. This is light that is between ultraviolet light and x-ray light in the electromagnetic spectrum and is not visible to our eyes directly.</p><p>Data supplied courtesy of SOHO. SOHO is a project of international cooperation between ESA and NASA. To learn more visit the Solar and Heliospheric Observatory (SOHO) Website (sohowww.nascom.nasa.gov).</p>";
var text3 = "<p>Extreme Ultraviolet Imaging Telescope image of the Sun from the Solar and Heliospheric Observatory (SOHO) satellite. (EIT) full-field Fe XV 284 Angstroms.</p><p>This image is produced by extreme ultraviolet (EUV) light from the Sun. This is light that is between ultraviolet light and x-ray light in the electromagnetic spectrum and is not visible to our eyes directly. EIT (Extreme Ultraviolet Imaging Telescope) images are taken at four different wavelengths and four colors in order of wavelength (bluer=shorter wavelength, redder=longer) were assigned to represent each of them. Just as the human eye is capable of discriminating different colors in the visible, so EIT's four bandpasses discriminate among four colors in the extreme ultraviolet. In addition, each color table was carefully constructed to bring out typical features of its particular wavelength.</p><p>The red images have a wavelength of 304 Angstroms, the yellow are 284 Angstroms, the green are 195 Angstroms, and the blue are 171 Angstroms. (An Angstrom is a unit of length equal to one hundred-millionth of a centimeter.) So, just like in the visible spectrum red is the longest wavelength and blue is the shortest with yellow and green in between, the EIT image colors were chosen so that the longest wavelength is reddish and the shortest is bluish.</p><p>All of the EIT images are actually produced by extreme ultraviolet (EUV) light from the Sun. This is light that is between ultraviolet light and x-ray light in the electromagnetic spectrum and is not visible to our eyes directly.<br><br>Data supplied courtesy of SOHO. SOHO is a project of international cooperation between ESA and NASA. To learn more visit the Solar and Heliospheric Observatory (SOHO) Website (sohowww.nascom.nasa.gov).</p>";
var text1 = "<p>Extreme Ultraviolet Imaging Telescope image of the Sun from the Solar and Heliospheric Observatory (SOHO) satellite. (EIT) full-field He II 304 Angstroms.</p><p>EIT images are taken at four different wavelengths and four colors in order of wavelength (bluer=shorter wavelength, redder=longer) were assigned to represent each of them. Just as the human eye is capable of discriminating different colors in the visible, so EIT's four bandpasses discriminate among four colors in the extreme ultraviolet. In addition, each color table was carefully constructed to bring out typical features of its particular wavelength.</p><p>The red images have a wavelength of 304 Angstroms, the yellow are 284 Angstroms, the green are 195 Angstroms, and the blue are 171 Angstroms. So, just like in the visible spectrum red is the longest wavelength and blue is the shortest with yellow and green in between, the EIT image colors were chosen so that the longest wavelength is reddish and the shortest is bluish.</p><p>All of the EIT images are actually produced by extreme ultraviolet (EUV) light from the Sun. This is light that is between ultraviolet light and x-ray light in the electromagnetic spectrum and is not visible to our eyes directly.</p><p>Data supplied courtesy of SOHO. SOHO is a project of international cooperation between ESA and NASA. To learn more visit the Solar and Heliospheric Observatory (SOHO)Website (sohowww.nascom.nasa.gov).</p>";
var text5 = "<p>The Large Angle and Spectrometric Coronagraph Experiment (LASCO C2) image of the Sun from the Solar and Heliospheric Observatory (SOHO) satellite.</p><p>Because the Sun is so bright, an occulting disk is used to block the direct light. The small circle on the occulting disk represents the size of the Sun. You should be able to see the mounting arm (at about 7 o'clock) holding the occulting disk in place.</p><p>The artificial eclipse created by the occulting disk makes it possible to view the Sun's corona--the outermost layer of the Sun's atmosphere. This type of instrument is called a coronagraph. LASCO contains three coronagraphs each with a different sized occulting disk, allowing us to view fainter areas of the corona further away from the Sun. Images taken with each coronagraph are color coded with false colors so scientist can quickly tell them apart.In the images you'll be able to see coronal streamers which are structures formed by the Sun's magnetic field. Occasionally, you may be able to see coronal mass ejections (CMEs). They appear as eruptions of particles that blow out from the Sun's corona at high speed.</p><p>Data supplied courtesy of SOHO/LASCO. SOHO is a project of international cooperation between ESA and NASA. To learn more visit the  LASCO/SOHO Coronagraph home page (lasco-www.nrl.navy.mil/lasco.html) or the Solar and Heliospheric Observatory (SOHO) Website (sohowww.nascom.nasa.gov).</p>";
var text6 = "<p>The Large Angle and Spectrometric Coronagraph Experiment (LASCO C3) image of the Sun from the Solar and Heliospheric Observatory (SOHO) satellite.</p><p>Because the Sun is so bright, an occulting disk is used to block the direct light. The small circle on the occulting disk represents the size of the Sun. You should be able to see the mounting arm (at about 7 o'clock) holding the occulting disk in place.</p><p>The artificial eclipse created by the occulting disk makes it possible to view the Sun's corona--the outermost layer of the Sun's atmosphere. This type of instrument is called a coronagraph.</p><p>LASCO contains three coronagraphs each with a different sized occulting disk, allowing us to view fainter areas of the corona further away from the Sun. Images taken with each coronagraph are color coded with false colors so scientist can quickly tell them apart.<br><br>In the images you'll be able to see coronal streamers which are structures formed by the Sun's magnetic field. Occasionally, you may be able to see coronal mass ejections (CMEs). They appear as eruptions of particles that blow out from the Sun's corona at high speed.</p><p>Data supplied courtesy of SOHO/LASCO. SOHO is a project of international cooperation between ESA and NASA. To learn more visit the  LASCO/SOHO Coronagraph home page (lasco-www.nrl.navy.mil/lasco.html) or the Solar and Heliospheric Observatory (SOHO) Website (sohowww.nascom.nasa.gov).</p>";
var text7 = "<p>Transition Region and Coronal Explorer (TRACE) satellite image of the Sun.</p><p>This full disk image of the Sun provided by TRACE will only be updated when images from the SOHO satellite are not available. Be sure to zoom in on the image and check the date and time. The TRACE 171 Angstrom image can show 1 to 2 million degree coronal loops at the edges of the solar disk.  (An Angstrom is a unit of length equal to one hundred-millionth of a centimeter.)</p><p>In most of these images you should see dark and light sunspot areas on the surface of the Sun. If you view these images over a series of days and weeks, you may notice that these sunspot areas move across the face of the Sun as it slowly rotates.</p><p>Please note that this full-disk image is only available when SOHO images are not. Data supplied courtesy of the TRACE Mission. To learn more visit the TRACE Online Website (vestige.lmsal.com/TRACE).</p>";
var text8 = "<p>White Light image of the Sun from Big Bear Solar Observatory.</p><p>This white light or visible light image was taken from an Earth-based observatory located in Big Bear Lake, California. Depending on the activity of Sun you may be able to see sunspots, which appear as darker regions. In many cases, these spots will correspond to active areas that you may see in the Extreme Ultraviolet images.</p><p>Data supplied courtesy of the Big Bear Solar Observatory. To learn more visit the  Big Bear Solar Observatory Website (www.bbso.njit.edu).</p>";
var text9 = "<p>H-Alpha Full Disk image of the Sun from Big Bear Solar Observatory.</p><p>This H-Alpha image was taken from an Earth-based observatory located in Big Bear Lake, California. H-Alpha images are taken in the red portion of the visible spectrum. Depending on the activity of the Sun you may be able to see dark sunspots and bright plage. These appear in areas of strong magnetic field which correspond to active areas that you may see in the Extreme Ultraviolet images. You often also see long, dark filaments, which appear as bright prominences on the limb. These sometimes erupt and can be parts of coronal mass ejections.</p><p>Data supplied courtesy of the Big Bear Solar Observatory. To learn more visit the  Big Bear Solar Observatory Website (www.bbso.njit.edu).</p>";

images[3] = {thumb:"http://ds9.ssl.berkeley.edu/imageviewer/images/images2/latest_eit_171_65.jpg",large:"http://ds9.ssl.berkeley.edu/imageviewer/images/images2/latest_eit_171_512.jpg",full:"http://ds9.ssl.berkeley.edu/imageviewer/images/images2/latest_eit_171_full.jpg",description:text4};
images[1] = {thumb:"http://ds9.ssl.berkeley.edu/imageviewer/images/images2/latest_eit_195_65.jpg",large:"http://ds9.ssl.berkeley.edu/imageviewer/images/images2/latest_eit_195_512.jpg",full:"http://ds9.ssl.berkeley.edu/imageviewer/images/images2/latest_eit_195_full.jpg",description:text2};
images[2] = {thumb:"http://ds9.ssl.berkeley.edu/imageviewer/images/images2/latest_eit_284_65.jpg",large:"http://ds9.ssl.berkeley.edu/imageviewer/images/images2/latest_eit_284_512.jpg",full:"http://ds9.ssl.berkeley.edu/imageviewer/images/images2/latest_eit_284_full.jpg",description:text3};           
images[0] = {thumb:"http://ds9.ssl.berkeley.edu/imageviewer/images/images2/latest_eit_304_65.jpg",large:"http://ds9.ssl.berkeley.edu/imageviewer/images/images2/latest_eit_304_512.jpg",full:"http://ds9.ssl.berkeley.edu/imageviewer/images/images2/latest_eit_304_full.jpg",description:text1};
images[4] = {thumb:"http://ds9.ssl.berkeley.edu/imageviewer/images/images2/latest_LASCOc2_65.jpg",large:"http://ds9.ssl.berkeley.edu/imageviewer/images/images2/latest_LASCOc2_512.jpg",full:"http://ds9.ssl.berkeley.edu/imageviewer/images/images2/latest_LASCOc2_full.jpg",description:text5};
images[5] = {thumb:"http://ds9.ssl.berkeley.edu/imageviewer/images/images2/latest_LASCOc3_65.jpg",large:"http://ds9.ssl.berkeley.edu/imageviewer/images/images2/latest_LASCOc3_512.jpg",full:"http://ds9.ssl.berkeley.edu/imageviewer/images/images2/latest_LASCOc3_full.jpg",description:text6};
images[6] = {thumb:"http://ds9.ssl.berkeley.edu/imageviewer/images/images2/latest_trace_171_65.jpg",large:"http://ds9.ssl.berkeley.edu/imageviewer/images/images2/latest_trace_171_512.jpg",full:"http://ds9.ssl.berkeley.edu/imageviewer/images/images2/latest_trace_171_full.jpg",description:text7};
images[7] = {thumb:"http://ds9.ssl.berkeley.edu/imageviewer/images/images2/latest_bbso_white_65.jpg",large:"http://ds9.ssl.berkeley.edu/imageviewer/images/images2/latest_bbso_white_512.jpg",full:"http://ds9.ssl.berkeley.edu/imageviewer/images/images2/latest_bbso_white_full.jpg",description:text8};
images[8] = {thumb:"http://ds9.ssl.berkeley.edu/imageviewer/images/images2/latest_bbso_halpha_65.jpg",large:"http://ds9.ssl.berkeley.edu/imageviewer/images/images2/latest_bbso_halpha_512.jpg",full:"http://ds9.ssl.berkeley.edu/imageviewer/images/images2/latest_bbso_halpha_1024.jpg",description:text9};

function setUp() {
    document.getElementById('fullImage').src = images[0].large;
    document.getElementById('description').innerHTML = images[0].description;

    for (i=0; i <= 8; i++) {
        num = i + 1;
        document.getElementById('thumb_' + num).src = images[i].thumb;
    }

    gMyScrollbar = new AppleVerticalScrollbar( document.getElementById("thumbscroll"));
    gMyScrollArea = new AppleScrollArea( document.getElementById("thumbs"));
    gMyScrollArea.addScrollbar(gMyScrollbar);
    gMyScrollbar2 = new AppleVerticalScrollbar( document.getElementById("dscroll"));
    gMyScrollArea2 = new AppleScrollArea( document.getElementById("description"));
    gMyScrollArea2.addScrollbar(gMyScrollbar2);
    gDoneButton = new AppleGlassButton(document.getElementById("doneButton"), "Back", function(){
        var front = document.getElementById("frontpanel");
        var back = document.getElementById("backpanel");

        if(window.widget)
            widget.prepareForTransition("ToBack");

        front.style.display = "block";
        back.style.display = "none";

        if(window.widget)
            setTimeout('widget.performTransition();', 0.1);
    });

    gInfoButton = new AppleInfoButton(document.getElementById("infoButton"),
        document.getElementById("frontpanel"), "white", "white", function(){

        var front = document.getElementById("frontpanel");
        var back = document.getElementById("backpanel");

        if(window.widget)
            widget.prepareForTransition("ToFront");

        front.style.display = "none";
        back.style.display = "block";

        if(window.widget)
            setTimeout('widget.performTransition();', 0.1);
            setTimeout('widget.performTransition();', 0.1);
            setTimeout('widget.performTransition();', 0.1);

    });
}

function moveDrawer(drawerNum){
    var i = 0;

    function handler(animation, current, start, finish){
        document.getElementById(drawer[i].id).style.top = current + 'px';
    }

    currentAnimator = new AppleAnimator(900, 13);
    closeAnimator = new AppleAnimator(700, 13);
    close_all = false;

    for(i=0; i< drawer.length; i++){
        var cnode = document.getElementById(drawer[i].button + '_img');
        if(drawer[i].open){
            if(cnode.src != 'arrow.gif')
                cnode.src = 'arrow.gif';

            if(i == drawerNum)
                close_all = true;

            var closed = document.getElementById(drawer[i].id);
            closed.style.top = '100px';
            closeAnimation = new AppleAnimation(270,0,function(animation, current, start, finish){
                closed.style.top = current + 'px';
                if(finish)
                    window.resizeBy(0, -300);

            });
            closeAnimator.addAnimation(closeAnimation);
            drawer[i].open = false;
            closeAnimator.start();
            break;
        }else{
            cnode.src = 'arrow_first.gif'; // Just in case.
        }
    }


    if(!close_all){
        i = drawerNum;
        document.getElementById(drawer[i].button + '_img').src = 'arrow_down.gif';
        var focus = document.getElementById(drawer[i].id);
        currentAnimation = new AppleAnimation(0,270,function(animation, current, start, finish){
            focus.style.top = current + 'px';
        });
        window.resizeBy(0, 300);
        currentAnimator.addAnimation(currentAnimation);
        currentAnimator.start();


        drawer[i].open = true;
    }
}

function updateImage(imgNumber){
    num = imgNumber - 1;
    focal_image = num;
    document.getElementById('fullImage').src = images[num].large + '?p=' + Math.random() * 500;
    document.getElementById('description').innerHTML = "<p>" + images[num].description + "</p>";
}

function moveLeft(){
    document.getElementById('innerthumbs').style.left = "-60px";
}

function moveRight(){

}

function full(){
    widget.openURL(images[focal_image].full);
}
