

function AmazonSearcher(progressBar){
	this.progressBar = progressBar;
	this.keywords = new Array();
	this.requests = new Array();
	this.addedRequests = new Array();
	this.inSearch = false;
	this.paused = false;
}

AmazonSearcher.prototype.initSearch = function(){
	showProgressBar(true);
	this.inSearch = true;
	
	this.keywords = new Array();
	this.requests = new Array();
	this.addedRequests = new Array();
	
	this.tagCount = 0;
	this.tagsProcessed = 0;
	if(purge){
		albumHandler.cleanOld();
	}
}

AmazonSearcher.prototype.allKeywordsSent = function(){
	//if one tag remains, build a single search for it
	if(this.keywords.length > 0){
		var request = 'http://xml-us.amznxslt.com/onca/xml?Service=AWSECommerceService&SubscriptionId=03QESZKGGC06TC13YAG2&AssociateTag=jimgeorgecom-20&Operation=ItemSearch&SearchIndex=Music&Artist=' + this.keywords[0] +'&ResponseGroup=Medium&Sort=-orig-rel-date&Style=http://jim-george.com/newTunes/xsl/newTunes-2.0.xsl&ContentType=text/javascript&CallBack=amzJSONCallback';
		this.queueRequest(request);
	}
	this.progressBar.setMax(this.tagCount);
}


//add a keyword to the request batch
AmazonSearcher.prototype.pushKeyword = function(keyword){
	this.keywords.push(keyword);
	if(this.keywords.length == 2){
		//build a request for the keywords
		var request = 'http://xml-us.amznxslt.com/onca/xml?Service=AWSECommerceService&SubscriptionId=03QESZKGGC06TC13YAG2&AssociateTag=jimgeorgecom-20&Operation=ItemSearch&Sort=-orig-rel-date&ItemSearch.Shared.SearchIndex=Music&ItemSearch.1.Artist=' + this.keywords[0] +'&ItemSearch.2.Artist=' + this.keywords[1] +'&ResponseGroup=Medium&Style=http://jim-george.com/newTunes/xsl/newTunes-2.0.xsl&ContentType=text/javascript&CallBack=amzJSONCallback';
		this.queueRequest(request);
	}
}

AmazonSearcher.prototype.queueRequest = function(request){
	aObj = new JSONscriptRequest(request);
	aObj.buildScriptTag();
	this.requests.unshift(aObj);
	this.tagCount++;
	//reset the array
	this.keywords = new Array();
	//if this is the first query, start the process.
	if(this.tagCount == 1){
		this.pullQuery();
	}
}

AmazonSearcher.prototype.cancel = function(){
	displayFinished();
	var self = this;
	setTimeout(function(){
		//delete script tags
		var req;
		while((req = self.addedRequests.shift()) != null){
			req.removeScriptTag();
		}
	}, 10000);
	
	delete this.addedRequests;
	self.addedRequests = new Array();	
	
	//cleaar out pending searches
	if(this.timer){
		clearTimeout(this.timer);
		this.timer = null;
	}
	
	this.paused = false;
	this.inSearch = false;
}

AmazonSearcher.prototype.pause = function(){
	this.paused = true;
	if(this.timer){
		clearTimeout(this.timer);
		this.timer = null;
	}
}

AmazonSearcher.prototype.unpause = function(){
	this.paused = false;
	this.pullQuery();
}

// Callback function referenced by the JSON script
var amzJSONCallback = function(tmpData){
	albumHandler.addAlbums(tmpData);
}

/**
 * Method to pull items off of the query queue.
 * Recall every second to adhere to AWS's time restrictions
 */
AmazonSearcher.prototype.pullQuery = function(){
	//if we are searchering and tags are left, pull...otherwise its over, kill it all
	if(this.inSearch && this.tagsProcessed < this.tagCount){
		//if it isn't paused, pull and recurse...otherwise stop the loop
		if(!this.paused){
			if(this.requests.length > 0){
				var query = this.requests.pop();
				query.addScriptTag();
				this.addedRequests.push(query);
				this.progressBar.update(++this.tagsProcessed);
			}
			this.timer = setTimeout(function() { searcher.pullQuery(); }, 1000);
		}
	}else{
		//call cancel on ourselves to end the search
		this.cancel();
	}
}

// JSON ScriptBuilder Function and Prototype, from Jason Levitt of Yahoo!
// code found here: http://devx.com/webdev/Article/30860/1954
function JSONscriptRequest(fullUrl, searchText) {
	this.fullUrl = fullUrl;
	this.headLoc = document.getElementsByTagName("head").item(0);
	this.scriptId = 'azScriptId' + JSONscriptRequest.scriptCounter++;
}

JSONscriptRequest.scriptCounter = 1;

JSONscriptRequest.prototype.buildScriptTag = function () {
	this.scriptObj = document.createElement("script");
	this.scriptObj.setAttribute("type", "text/javascript");
	this.scriptObj.setAttribute("src", this.fullUrl);
	this.scriptObj.setAttribute("id", this.scriptId);
	this.scriptObj.setAttribute("charset","utf-8");
}

JSONscriptRequest.prototype.removeScriptTag = function () {
	this.headLoc.removeChild(this.scriptObj);
}

JSONscriptRequest.prototype.addScriptTag = function () {
	this.headLoc.appendChild(this.scriptObj);
}
