var backgroundSearches;
var purge;
var allowUpdate;
var firstRun;
var curVersion;
var whenUpdated;

function PreferenceHandler(){
	/*empty constructor...use only static methods for clarity*/;
}

PreferenceHandler.showPrefs = function() {
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	if (window.widget){
		widget.prepareForTransition("ToBack");
	}
	front.style.display="none";
	back.style.display="block";
	dimensions = { x : window.innerWidth, y : window.innerHeight };
	window.resizeTo(minSize.x, minSize.y);
	if (window.widget){
		setTimeout('widget.performTransition();', 0);
	}
}

PreferenceHandler.hidePrefs = function() {
	var front = document.getElementById("front");
	var back = document.getElementById("back");

	window.resizeTo(dimensions.x,dimensions.y);
	if (window.widget){
		widget.prepareForTransition("ToFront");
	}

	back.style.display  = "none";
	front.style.display = "block";

	if (window.widget){
		setTimeout('widget.performTransition();', 0);
	}
	PreferenceHandler.savePrefs();
}


PreferenceHandler.savePrefs = function(){
	var daysBox  = document.getElementById("prefDaysBox");
	var specDays = daysBox.value;
		
	if(specDays != "" && isNumeric(specDays)){
		tooOld = specDays;
	}else{
		tooOld = 90;
		daysBox.value = 90;
	}
	widget.setPreferenceForKey(tooOld,"age");
	
	backgroundSearches = document.getElementById("prefBackgroundSearchBox").checked == 1;
	if(backgroundSearches){
		widget.setPreferenceForKey("true", "bgs");
	}else{
		widget.setPreferenceForKey("false", "bgs");
	}
	
	purge = document.getElementById("prefAllowPurge").checked == 1;
	if(purge){
		widget.setPreferenceForKey("true", "purge");
		
	}else{
		widget.setPreferenceForKey("false", "purge");
	}
	
	allowUpdate = document.getElementById("prefAllowUpdate").checked == 1;
	if(allowUpdate){
		widget.setPreferenceForKey("true", "allowUpdate");
	}else{
		widget.setPreferenceForKey("false", "allowUpdate");
	}
	
	//serialize cd information
	widget.setPreferenceForKey(Artist.toJSON(), "artists");
	widget.setPreferenceForKey(albumHandler.getAlbumsInJSON(), "cds");
	
	//versioning
	widget.setPreferenceForKey(curVersion, "curVersion");
	widget.setPreferenceForKey(whenUpdated, "whenUpdated");
}

PreferenceHandler.loadPrefs = function(){
	//get age preference
	var age = widget.preferenceForKey("age");
	if(age && age.length > 0){
		tooOld = age;
	}else{
		tooOld = 90;
	}
	document.getElementById("prefDaysBox").value = tooOld;
	
	//get 'allow background searches'
	if(widget.preferenceForKey("bgs") == "false"){
		backgroundSearches = false;
		document.getElementById("prefBackgroundSearchBox").checked = 0;
	}else{
		backgroundSearches = true;
		document.getElementById("prefBackgroundSearchBox").checked = 1;
	}

	//get allow purge
	if(widget.preferenceForKey("purge") == "false"){
		purge = false;
		document.getElementById("prefAllowPurge").checked = 0;
	}else{
		purge = true;
		document.getElementById("prefAllowPurge").checked = 1;
	}
	
	//get check updates
	if(widget.preferenceForKey("allowUpdate") == "false"){
		allowUpdate = false;
		document.getElementById("prefAllowUpdate").checked = 0;
	}else{
		allowUpdate = true;
		document.getElementById("prefAllowUpdate").checked = 1;
	}
	//check up to date status
	curVersion = widget.preferenceForKey("curVersion");
	whenUpdated = widget.preferenceForKey("whenUpdated");
	
	//get the type of sort for albums
	var sortType = widget.preferenceForKey("sort");
	if(sortType == "date"){
		AlbumHandler.sortByDate = true;
	}else{
		AlbumHandler.sortByDate = false;
	}
	
	//get the type of sort for albums
	var sortType = widget.preferenceForKey("sortOrder");
	if(sortType == "-1"){
		AlbumHandler.sortOrder = -1;
	}else{
		AlbumHandler.sortOrder = 1;
	}
	
	PreferenceHandler.tryFirstRun();
	if(firstRun){
		return;
	}
	//reconstruct artist list
	var artists = widget.preferenceForKey("artists");
	if(artists && artists.length > 0){
		var artistObj = eval(artists);
		var array = artistObj.artists;
		//construct the list
		Artist.buildList(array);
	}
	
	//get album content
	var cdJSON = widget.preferenceForKey("cds");
	if(cdJSON && cdJSON.length > 0){
		var albumObj = eval(cdJSON); 
		var cds = albumObj.cds;
		for(var i = 0; i < cds.length; i++){
			//pass in true to say it is an old album
			albumHandler.addAlbum(new Album(cds[i], true));
		}
		//create the excluded album object
		var kills = albumObj.kill;
		for(var i = 0; i < kills.length; i++){
			albumHandler.killList.add(kills[i]);
		}
		//create favorite list
		var favs = albumObj.favorite;
		for(var i = 0; i < favs.length; i++){
			albumHandler.favorites.addAlbum(new Album(favs[i], true));
		}
	}	
}

PreferenceHandler.tryFirstRun = function(){
	//do this on the first run
	if(!widget.preferenceForKey("notFirstRun")){
		PreferenceHandler.nullifyPreferences();
		loadLibrary();
		firstRun = true;
		document.getElementById("tab-text").innerText = "press play to begin";
		widget.setPreferenceForKey("ran", "notFirstRun");
	}else{
	 	firstRun = false;
	}
}

PreferenceHandler.nullifyPreferences = function(){
	widget.setPreferenceForKey(null,"age");
	widget.setPreferenceForKey(null,"artists");
	widget.setPreferenceForKey(null,"cds");
	widget.setPreferenceForKey(null,"excluded");
	widget.setPreferenceForKey(null,"bgs");
	widget.setPreferenceForKey(null,"allowUpdate");
	widget.setPreferenceForKey(null,"sort");
	widget.setPreferenceForKey(null,"whenUpdated");
	widget.setPreferenceForKey(null,"curVersion");
	widget.setPreferenceForKey(null,"purge");
	widget.setPreferenceForKey(null,"notFirstRun");
	//deprecated 
	widget.setPreferenceForKey(null,"isUpToDate");
}