
/**
 * Progress bar object definition.
 */
function ProgressBar(bottompx, startpx, width, minValue, maxValue, domEl, background, fill){
	this.startpx = startpx;
	this.width = width;
	this.domEl = domEl;
	this.minValue = minValue;
	this.maxValue = maxValue;
	this.curValue = minValue;
	
	this.backgroundEl = document.createElement("div");
	this.backgroundEl.setAttribute("class", "progressBar");
	this.backgroundEl.style.background = "url("+background+")";
	this.backgroundEl.style.left = startpx + "px";
	this.backgroundEl.style.width = width + "px";
	this.backgroundEl.style.bottom = bottompx + "px";
	
	this.filledEl = document.createElement("div");
	this.filledEl.setAttribute("class", "progressBar");
	this.filledEl.style.background = "url("+fill+")";
	this.filledEl.style.left = startpx + "px";
	this.filledEl.style.width = "0px";
	this.filledEl.style.bottom = bottompx + "px";
	
	this.domEl.appendChild(this.backgroundEl);
	this.domEl.appendChild(this.filledEl);

	var self = this;
	this.update = function(curValue){
		self.curValue = curValue;
		self.filledEl.style.width = ( curValue * (self.width) / (self.maxValue - self.minValue) ) + "px";
	}
	
	this.setMax = function(maxValue){
		self.maxValue = maxValue;
		self.update(self.curValue);
	}
	
	this.setWidth = function(width){
		self.width = width;
		self.backgroundEl.style.width = width + "px";
		self.update(self.curValue);
	}
}