//definitions for an object to handle the behavior of 'radio like' buttons
//for newTunes.


ToggleButton = function(element, action, image, hover_image, selected_image, selected_hover, hover_text_el, hover_text, toggle_text){
	this.element = element;
	this.image = image;
	this.hover_image = hover_image;
	this.selected_image = selected_image;
	this.selected_hover = selected_hover;
	this.isSelected = false;
	this.action = action;
	this.hover_text_el = hover_text_el;
	this.hover_text = hover_text;
	this.toggle_text = toggle_text;
	this.toggleOnClick = true;
	
	var self = this;
	
	this.clicked = function(){
		if(self.toggleOnClick){
			self.toggleSelected();
		}
		self.action(self.isSelected);
	}
	
	this.deselect = function(){
		self.isSelected = false;
		self.element.src = self.image;
	}
	
	this.toggleSelected = function(){
		if(self.isSelected){
			self.element.src = self.image;
		}else{
			self.element.src = self.selected_image;
		}
		self.isSelected = !self.isSelected;	
	}
		
	this.hoverOn = function(){
		if(!self.isSelected){
			self.element.src = self.hover_image;
		}else{
			self.element.src = self.selected_hover;
		}
		
		if(self.hover_text_el && self.hover_text){
			if(self.toggle_text && self.isSelected){
				self.hover_text_el.innerText = self.toggle_text;
			}else{
				self.hover_text_el.innerText = self.hover_text;
			}
		}
	}
	
	this.hoverOff = function(){
		if(self.isSelected){
			self.element.src = self.selected_image;
		}else{
			self.element.src = self.image;
		}
		
		if(self.hover_text_el && self.hover_text){
			self.hover_text_el.innerText = "";
		}
	}
	
	this.show = function(show){
		if(show){
			self.element.style.display = "block";
		}else{
			self.element.style.display = "none";
		}
	}
	
	this.element.src = image;
	this.element.onmouseover = this.hoverOn;
	this.element.onmouseout = this.hoverOff;
	this.element.onclick = this.clicked;
}

ToggleButton.prototype.setToggleOnClick = function(toggle){
	this.toggleOnClick = toggle;
}

/**
 * Defines a simple button that supports hover image and text
 */
function SimpleButton(element, action, image, hover_image, hover_text_el, hover_text){
	this.element = element;
	this.action = action;
	this.image = image;
	this.hover_image = hover_image;
	this.hover_text_el = hover_text_el;
	this.hover_text = hover_text;
	
	this.element.src = image;
	this.element.onclick = action;
	var self = this;
	
	this.element.onmouseover = function(){
		self.element.src = self.hover_image;
		if(self.hover_text_el && self.hover_text){
			self.hover_text_el.innerText = self.hover_text;
		}
	}
	
	this.element.onmouseout = function(){
		self.element.src = self.image;
		if(self.hover_text_el && self.hover_text){
			self.hover_text_el.innerText = "";
		}
	}
	
	this.show = function(show){
		if(show){
			self.element.style.display = "block";
		}else{
			self.element.style.display = "none";
		}
	}
	
	this.setAction = function(newAction){
		self.action = newAction;
		self.element.onclick = self.action;
	}
}