
function loadLibrary(){
	if(newTunesPlugin){
		var success = newTunesPlugin.beginParse("~/Music/iTunes/iTunes Music Library.xml");
		if(success == 1){
			var attempt = newTunesPlugin.getArtists();
			loadArtistsFromString(attempt);
		}else{
			setStatus("iTunes XML file missing or corrupted!");
		}
	}else{
		//alert("plug in not loaded!");
	}
}

//---------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------
function loadArtistsFromString(artists){
	//parse out goofy characters
	artists = artists.replace(/(<|>|\/|'|"|{|}|\[|\]|,)/g,  " ");
	var all_artists = artists.split("_SPLIT_");
	all_artists.pop();  //kill the trailing empty entry
	all_artists.sort(mySort);
	
	//cache currently excluded artists.
	var excluded = [ ];
	for(var i = 0; i < Artist.items.length; i++){
		if(!Artist.items[i].isIncluded()){
			//flag the artist as excluded
			excluded[Artist.items[i].getName()] = true;
		}
	}
	var artistObjects = [ ];
	for(var i = 0; i < all_artists.length; i++){
		//if the artist exists in the excluded hash set, mark it as excluded...also give it its name
		var next = { "included" : excluded[all_artists[i]] ? false : true , "name" : all_artists[i] };
		artistObjects.push(next);
	}

	//construct the list
	//this call will recurse through all artists building a linked list
	//and appending elements to the document.
	deleteChildren(artistList);	
	Artist.buildList(artistObjects);
	Artist.query();
	scrollArea.refresh();
}

function mySort(a,b) {
	var A = a.toLowerCase().replace(/^the /gi, "");
	var B = b.toLowerCase().replace(/^the /gi, "");
	if (A < B) 
		return -1;
	if (A > B) 
		return 1;
	return 0;
}
